<?php
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."user_fields_creator/infusion_db.php";
include_once INCLUDES."infusions_include.php";

if (file_exists(INFUSIONS."user_fields_creator/locale/".$settings['locale'].".php")) {
	include INFUSIONS."user_fields_creator/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."user_fields_creator/locale/English.php";
}

if (!defined("UF_PATH")) {
	define("UF_PATH", INCLUDES."user_fields/");
}

$ufc_settings = get_settings("user_fields_creator");

function clean_field_name($text) {
	$text = preg_replace("/[^a-zA-Z0-9_-\s]/", "", $text);
	$text = str_replace(" ", "", $text);
	$text = preg_replace("/([\s\s]+|[--]+)/", "-", $text);
	$text = strtolower($text);
	
	return $text;
}

function docs_opts($files, $selected = "") {
	$res = "";
	for ($i = 0; $i < count($files); $i++) {
		$sel = ($selected == $files[$i] ? " selected='selected'" : "");
		$res .= "<option value='".str_replace(".php", "", $files[$i])."'$sel>".str_replace(".php", "", $files[$i])."</option>\n";
	}
	return $res;
}

function dbset_type_name($type) {
	global $locale;
	
	if ($type == 1) {
		$return = $locale['ufc_admin_09_000'];
	} elseif ($type == 2) {
		$return = $locale['ufc_admin_09_001'];
	} elseif ($type == 3) {
		$return = $locale['ufc_admin_09_002'];
	} elseif ($type == 4) {
		$return = $locale['ufc_admin_09_003'];
	}
	
	return $return;
}

function dbset_construction($dbset_id) {
	$result = dbquery("SELECT ufc_dbset_id, ufc_dbset_name, ufc_dbset_type, ufc_dbset_maxlength, ufc_dbset_default FROM ".DB_UFC_DBSET." WHERE ufc_dbset_id='".$dbset_id."'");
	if (dbrows($result) != 0) {
		$data = dbarray($result);
		
		if ($data['ufc_dbset_type'] == 1) {
			$return = "TEXT NOT NULL";
		} elseif ($data['ufc_dbset_type'] == 2) {
			$return = "VARCHAR(".$data['ufc_dbset_maxlength'].") NOT NULL DEFAULT ''";
		} elseif ($data['ufc_dbset_type'] == 3) {
			if ($data['ufc_dbset_maxlength'] < 3) {
				$type = "TINYINT";
			} elseif ($data['ufc_dbset_maxlength'] < 6) {
				$type = "SMALLINT";
			} elseif ($data['ufc_dbset_maxlength'] < 9) {
				$type = "MEDIUMINT";
			} elseif ($data['ufc_dbset_maxlength'] < 16) {
				$type = "INT";
			} elseif ($data['ufc_dbset_maxlength'] >= 16) {
				$type = "BIGINT";
			}
			$return = $type."(".$data['ufc_dbset_maxlength'].") UNSIGNED NOT NULL DEFAULT '0'";
		} elseif ($data['ufc_dbset_type'] == 4) {
			$return = "TINYINT(1) UNSIGNED NOT NULL DEFAULT '".$data['ufc_dbset_default']."'";
		}
	} else {
		$return = "VARCHAR(255) NOT NULL DEFAULT ''";
	}
	
	return $return;
}

function dbset_get_type($dbset_id) {
	$result = dbquery("SELECT ufc_dbset_type FROM ".DB_UFC_DBSET." WHERE ufc_dbset_id='".$dbset_id."'");
	if (dbrows($result) != 0) {
		$data = dbarray($result);
		return $data['ufc_dbset_type'];
	} else {
		return FALSE;
	}
}

function tooltip($rel, $class = FALSE, $gen = FALSE) {
	global $ufc_settings, $locale;
	
	if ($ufc_settings['ufc_info'] == 1) {
		if (!$gen && $class) {
			$return = "class='addtt'";
		} elseif (!$class && $gen) {
			$return = "<a ".tooltip("", TRUE)." ".tooltip($rel)."><img src='".INFUSIONS."user_fields_creator/images/info.gif' alt='".$locale['ufc_admin_11_000']."' /></a>";
		} elseif (!$class && !$gen) {
			$rel = !empty($rel) ? "rel='".$rel."'" : "";
			$return = $rel;
		} else {
			$return = "";
		}
		
		return $return;
	}
}
?>